/* gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1999, 2000, 2001, 2002, 2003, 2009 Free Software
Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define BITS_PER_MP_LIMB 32
#define BYTES_PER_MP_LIMB 4

/* 593MHz ARM (gcc50.fsffrance.org) */

/* Generated by tuneup.c, 2009-03-05, gcc 4.3 */

#define MUL_KARATSUBA_THRESHOLD          34
#define MUL_TOOM3_THRESHOLD             125
#define MUL_TOOM44_THRESHOLD            184

#define SQR_BASECASE_THRESHOLD           15
#define SQR_KARATSUBA_THRESHOLD          82
#define SQR_TOOM3_THRESHOLD             147
#define SQR_TOOM4_THRESHOLD             212

#define MULLOW_BASECASE_THRESHOLD         0  /* always */
#define MULLOW_DC_THRESHOLD             128
#define MULLOW_MUL_N_THRESHOLD         1095

#define DIV_SB_PREINV_THRESHOLD           0  /* preinv always */
#define DIV_DC_THRESHOLD                130
#define POWM_THRESHOLD                  200

#define MATRIX22_STRASSEN_THRESHOLD      19
#define HGCD_THRESHOLD                  110
#define GCD_DC_THRESHOLD                734
#define GCDEXT_DC_THRESHOLD             748
#define JACOBI_BASE_METHOD                2

#define DIVREM_1_NORM_THRESHOLD           0  /* preinv always */
#define DIVREM_1_UNNORM_THRESHOLD         0  /* always */
#define MOD_1_NORM_THRESHOLD              0  /* always */
#define MOD_1_UNNORM_THRESHOLD            0  /* always */
#define MOD_1_1_THRESHOLD                10
#define MOD_1_2_THRESHOLD               996
#define MOD_1_4_THRESHOLD               997
#define USE_PREINV_DIVREM_1               1  /* preinv always */
#define USE_PREINV_MOD_1                  1  /* preinv always */
#define DIVREM_2_THRESHOLD                0  /* preinv always */
#define DIVEXACT_1_THRESHOLD              0  /* always */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always */

#define GET_STR_DC_THRESHOLD             18
#define GET_STR_PRECOMPUTE_THRESHOLD     35
#define SET_STR_DC_THRESHOLD            321
#define SET_STR_PRECOMPUTE_THRESHOLD   1057

#define MUL_FFT_TABLE  { 400, 928, 1920, 4608, 14336, 40960, 0 }
#define MUL_FFT_MODF_THRESHOLD          416
#define MUL_FFT_THRESHOLD              5888

#define SQR_FFT_TABLE  { 432, 928, 1664, 4608, 10240, 40960, 0 }
#define SQR_FFT_MODF_THRESHOLD          376
#define SQR_FFT_THRESHOLD              4352
