/* gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1999, 2000, 2001, 2002, 2009 Free Software
Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define BITS_PER_MP_LIMB 32
#define BYTES_PER_MP_LIMB 4

/* Generated by tuneup.c, 2009-03-05, gcc 4.3 */

#define MUL_KARATSUBA_THRESHOLD          15
#define MUL_TOOM3_THRESHOLD              98
#define MUL_TOOM44_THRESHOLD            158

#define SQR_BASECASE_THRESHOLD            6
#define SQR_KARATSUBA_THRESHOLD          48
#define SQR_TOOM3_THRESHOLD              97
#define SQR_TOOM4_THRESHOLD             232

#define MULLOW_BASECASE_THRESHOLD         0  /* always */
#define MULLOW_DC_THRESHOLD              92
#define MULLOW_MUL_N_THRESHOLD          363

#define DIV_SB_PREINV_THRESHOLD           4
#define DIV_DC_THRESHOLD                 92
#define POWM_THRESHOLD                  142

#define MATRIX22_STRASSEN_THRESHOLD      17
#define HGCD_THRESHOLD                  100
#define GCD_DC_THRESHOLD                365
#define GCDEXT_DC_THRESHOLD             339
#define JACOBI_BASE_METHOD                2

#define DIVREM_1_NORM_THRESHOLD           3
#define DIVREM_1_UNNORM_THRESHOLD         5
#define MOD_1_NORM_THRESHOLD              4
#define MOD_1_UNNORM_THRESHOLD            5
#define MOD_1_1_THRESHOLD                 6
#define MOD_1_2_THRESHOLD                 9
#define MOD_1_4_THRESHOLD                24
#define USE_PREINV_DIVREM_1               1
#define USE_PREINV_MOD_1                  1
#define DIVREM_2_THRESHOLD                0  /* always */
#define DIVEXACT_1_THRESHOLD              0  /* always */
#define MODEXACT_1_ODD_THRESHOLD      MP_SIZE_T_MAX  /* never */

#define GET_STR_DC_THRESHOLD              8
#define GET_STR_PRECOMPUTE_THRESHOLD     13
#define SET_STR_DC_THRESHOLD            224
#define SET_STR_PRECOMPUTE_THRESHOLD    702

#define MUL_FFT_TABLE  { 272, 672, 896, 2560, 6144, 24576, 98304, 393216, 0 }
#define MUL_FFT_MODF_THRESHOLD          232
#define MUL_FFT_THRESHOLD              1792

#define SQR_FFT_TABLE  { 304, 672, 1152, 2560, 10240, 24576, 98304, 393216, 0 }
#define SQR_FFT_MODF_THRESHOLD          232
#define SQR_FFT_THRESHOLD              1792
