/* Intel Pentium-4 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000, 2001, 2002, 2003, 2004, 2005, 2007, 2008,
2009 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define BITS_PER_MP_LIMB 32
#define BYTES_PER_MP_LIMB 4


/* 2600 MHz Pentium 4 model 2 */

/* Generated by tuneup.c, 2009-01-06, gcc 3.4 */

#define MUL_KARATSUBA_THRESHOLD          31
#define MUL_TOOM3_THRESHOLD             119
#define MUL_TOOM44_THRESHOLD            178

#define SQR_BASECASE_THRESHOLD            0  /* always (native) */
#define SQR_KARATSUBA_THRESHOLD          49
#define SQR_TOOM3_THRESHOLD             165
#define SQR_TOOM4_THRESHOLD             252

#define MULLOW_BASECASE_THRESHOLD        15
#define MULLOW_DC_THRESHOLD              44
#define MULLOW_MUL_N_THRESHOLD          363

#define DIV_SB_PREINV_THRESHOLD       MP_SIZE_T_MAX  /* never */
#define DIV_DC_THRESHOLD                 33
#define POWM_THRESHOLD                   95

#define MATRIX22_STRASSEN_THRESHOLD      23
#define HGCD_THRESHOLD                   64
#define GCD_DC_THRESHOLD                310
#define GCDEXT_DC_THRESHOLD             310
#define JACOBI_BASE_METHOD                1

#define USE_PREINV_DIVREM_1               1  /* native */
#define USE_PREINV_MOD_1                  1  /* native */
#define DIVEXACT_1_THRESHOLD              0  /* always (native) */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always (native) */

#define GET_STR_DC_THRESHOLD             11
#define GET_STR_PRECOMPUTE_THRESHOLD     26
#define SET_STR_DC_THRESHOLD            118
#define SET_STR_PRECOMPUTE_THRESHOLD   1078

#define MUL_FFT_TABLE  { 560, 928, 1920, 5632, 14336, 40960, 0 }
#define MUL_FFT_MODF_THRESHOLD          720
#define MUL_FFT_THRESHOLD              9216

#define SQR_FFT_TABLE  { 592, 928, 1920, 4608, 14336, 40960, 0 }
#define SQR_FFT_MODF_THRESHOLD          608
#define SQR_FFT_THRESHOLD              5888
